/*!
 * @file gui_saveable.h
 * @brief Definition of ...
*/

#ifndef _GUI_SAVEABLE_H
#define _GUI_SAVEABLE_H

#include "base_object.h"
#include "multi_type.h"
#include <list>

// FORWARD DECLARATION


//! A class for ...
class GuiSaveable : virtual public BaseObject
{

public:


protected:
  GuiSaveable();
  virtual ~GuiSaveable();

  virtual void load(const MultiType& value) = 0;
  virtual const MultiType& save() = 0;

protected:
  MultiType       value;
};



class GuiGroup : virtual public BaseObject
{
public:
  GuiGroup(const char* name);
  ~GuiGroup();

  void addSaveable(GuiSaveable* saveable);

private:
  std::list<GuiSaveable*>     saveables;
};


#endif /* _GUI_SAVEABLE_H */
